﻿using DemoCommon.Grid;
using Syncfusion.Data;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.WinForms.DataGrid.Enums;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DataBinding
{
    public partial class Form1 : Form
    {
        #region Constructor
        public Form1()
        {
            InitializeComponent();

            this.sfDataGrid1.DataSource = this.GetDataTable();

            // Wires RecordPropertyChanged event to update "Last Modified Date"
            this.sfDataGrid1.View.RecordPropertyChanged += OnRecordPropertyChanged;
        }

        private void OnRecordPropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "Name")
            {
                // Updates the "Last Modified Date"
                this.sfDataGrid1.View.GetPropertyAccessProvider().SetValue(sender as DataRowView, "Last Modified Date", DateTime.Now);
            }
        }
        #endregion

        #region DataTable
        public DataTable GetDataTable()
        {
            DataTable employeeCollection = new DataTable();
            var dt = DateTime.Now;

            employeeCollection.Columns.Add("EmployeeID", typeof(int));
            employeeCollection.Columns[0].ColumnName = "Employee ID";
            employeeCollection.Columns.Add("EmployeeName", typeof(string));
            employeeCollection.Columns["EmployeeName"].ColumnName = "Name";
            employeeCollection.Columns.Add("CustomerID", typeof(string));
            employeeCollection.Columns["CustomerID"].ColumnName = "Customer ID";
            employeeCollection.Columns.Add("Country", typeof(string));
            employeeCollection.Columns.Add("LastModifiedDate", typeof(DateTime));
            employeeCollection.Columns["LastModifiedDate"].ColumnName = "Last Modified Date";

            employeeCollection.Rows.Add(1001, "Belgim", "Yhgtr", "US", new DateTime(dt.Year, dt.Month, dt.Day));
            employeeCollection.Rows.Add(1002, "Oliver", "Johanesberg", "UK", new DateTime(dt.Year, dt.Month, dt.AddDays(-1).Day));
            employeeCollection.Rows.Add(1003, "Bernald", "Alfki", "US", new DateTime(dt.Year, dt.Month, dt.AddDays(-5).Day));
            employeeCollection.Rows.Add(1004, "James", "Yhgtr", "Chicago", new DateTime(dt.Year, dt.Month, dt.AddDays(-1).Day));
            employeeCollection.Rows.Add(1005, "Beverton", "Bergs", "Spain", new DateTime(dt.Year, dt.Month, dt.Day));
            employeeCollection.Rows.Add(1005, "Berlin", "Johanesberg", "Spain", new DateTime(dt.Year, dt.Month, dt.AddDays(-4).Day));
            employeeCollection.Rows.Add(1006, "Fransis", "Alfki", "US", new DateTime(dt.Year, dt.Month, dt.Day));
            employeeCollection.Rows.Add(1006, "Fred", "Oregon", "US", new DateTime(dt.Year, dt.Month, dt.AddDays(-2).Day));
            employeeCollection.Rows.Add(1009, "Dintin", "Britain", "Britain", new DateTime(dt.Year, dt.Month, dt.AddDays(-2).Day));
            employeeCollection.Rows.Add(1009, "Diano", "Alfki", "Britain", new DateTime(dt.Year, dt.AddMonths(-5).Month, dt.Day));
            employeeCollection.Rows.Add(1010, "Joysie", "Oregon", "China", new DateTime(dt.Year, dt.Month, dt.AddDays(-2).Day));
            employeeCollection.Rows.Add(1016, "Friedo", "Bergs", "US", new DateTime(dt.Year, dt.AddMonths(-1).Month, dt.Day));
            employeeCollection.Rows.Add(1017, "George", "Oregon", "SwitzerLand", new DateTime(dt.Year, dt.Month, dt.AddDays(-2).Day));
            employeeCollection.Rows.Add(1011, "DintinAmam", "Alfki", "Britain", new DateTime(dt.AddYears(-7).Year, dt.Month, dt.Day));
            employeeCollection.Rows.Add(1012, "JohnAmam", "Johanesberg", "China", new DateTime(dt.Year, dt.Month, dt.AddDays(-2).Day));
            employeeCollection.Rows.Add(1012, "PaulPaulPaul", "Bergs", "China", new DateTime(dt.Year, dt.AddMonths(-5).Month, dt.Day));

            return employeeCollection;
        }

        #endregion
    }
}
